program lista_linked

  implicit none

  type element
     real :: x
     type (element), pointer :: next
  end type element
  type(element), pointer :: current, first
  integer :: i_count
  real, dimension(:), allocatable :: a

  print *,'creating the list structure'
  allocate(current) ; nullify(current%next)
  first => current     ; i_count = 0

  open(25,FILE='list.dat')

  print *,'populating the list'
  do
     read(25, *, end=100) current%x
     i_count = i_count + 1
     allocate(current%next); current => current%next; nullify(current%next)
  end do
100 close(25)

  write(*,*) 'read ', i_count, ' records'
  write(*,*) 'allocating arrays for data'
  allocate(a(i_count))

  print *,'copying to array'
  current => first; i_count = 0
  do while (associated(current%next))  
     write(*, '(3x, 3f6.2)') current%x
     i_count = i_count + 1
     a(i_count) = current%x
     current => current%next
  end do

  write(*,*) a(1:i_count), i_count
  write(*,*) maxval( a(1:i_count)), minval( a(1:i_count)), sum( a(1:i_count))/(i_count), a((i_count)/2)

end program lista_linked
